#!perl 

# Italian model for the AG-MEMOD project


&get_input;
if ($all_var) {
    $file_base       = "model_all.pl";
}
else {
    $file_base       = "model.pl";
}

&load_files;
&modify;
&html_out;

###############################################################
sub get_input {

use CGI qw(:standard);
    $query = new CGI;
	$country = $query->param('country');
	$method = $query->param('method');
	$all_var = $query->param('all_var');
	if (!$method) {$method="all";}
	$what = $query->param('what');
	if ($what eq "All the commodities") {$what = "all_equations";}
	if ($what eq "Grains and oilseeds") {$what = "\\*grains";}
	if ($what eq "Livestock and dairy") {$what = "\\*livestock";}
	if ($what eq "Sugar beet") {$what = "\\*sugarbeet";}
	if ($what eq "Potatoes") {$what = "\\*potatoes";}
	if ($what eq "Oranges") {$what = "\\*oranges";}
	if ($what eq "Olive oil") {$what = "\\*oliveoil";}
	if ($what eq "Tomato paste") {$what = "\\*tomatopaste";}
	if ($what eq "Tobacco") {$what = "\\*tobacco";}


if ($country eq "Italy") {
   $file_parameters = "parametri/it_model_parameters.txt";
   $file_data       = "dati/it_model_data.txt";
   $file_equations  = "modelli_grezzi/it_model.eq";
   $file_complete   = "modelli_ok/it_model.cgi";
   $model_title     = "Italian Model";
   $comment_key     = "\\*";
   $comment_elast   = "\\#";
   $par_delimiter   = "\\t";
   $data_delimiter  = "\\t";
   $end_commodity_flag   = "\\*\\*\\*\\*\\*\\*";
}
	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "parametri/eu11_model_parameters.txt";
      $file_data       = "dati/eu11_model_data.txt";
      $file_equations  = "modelli_grezzi/eu11_model.eq";
      $file_complete   = "modelli_ok/eu11_model.cgi";
      $model_title     = "EU11 Olive Oil Demand";
      $comment_key     = "\\*";
      $comment_elast   = "\\#";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
      $end_commodity_flag   = "\\*\\*\\*\\*\\*\\*";
	}


}


#################################################################
sub load_files {
   
  
       #Open parameters database
       open (PARAMETRI, "<$file_parameters");
       @parametr1=(<PARAMETRI>);
       close PARAMETRI;

       foreach $parametro(@parametr1){
          if ($parametro ne "\n") {
			 # I remove all the blanks
             $parametro =~ s/ //g;
			 # I change the commas, if presents, with the dots
             if ($par_delimiter ne ",") {$parametro =~ s/,/./g;}
		     # I change all the letters in lower case
             $parametro =~ tr/A-Z/a-z/;
             @par = split (/$par_delimiter/, $parametro,2);
	            if (@par[0] !~ /$comment_key/) {
                    push @par_names, @par[0];
			        chop @par[1];
	                ${@par[0]}=@par[1];
	            }
			}
          }

  
       #Open data database
       open (DATAREAD, "<$file_data");
       @hisdatas1=(<DATAREAD>);
       close DATAREAD;

       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
			 # I remove all the blanks
             $hisdata =~ s/ //g;
		     # I change the commas, if presents, with the dot
             if ($data_delimiter ne ",") {$hisdata =~ s/,/./g;}
		     # I change all the letters in lower case
             $hisdata =~ tr/A-Z/a-z/;
             @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/ && @dat[0] ne "") {
					push @data_names, @dat[0];
	            }
			}
          }

    #Open equation model
    open (EQUAZ, "<$file_equations");
    @equations1=(<EQUAZ>);
    close EQUAZ;
 	  
 	   #controllo che sia la parte del modello richiesta
 	   if ($what eq "all_equations") {$ctr_what = 1;}
 	   else {$ctr_what = 0;}
 	   
 	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $riga(@equations1){
          if ($riga ne "\n") {
 		    # I remove all the blanks
            $riga =~ s/ //g;
 		    # I remove all the comments key for the elasticity calculation
            $riga =~ s/$comment_elast//g;
 		    # I change all the letters in lower case
            $riga =~ tr/A-Z/a-z/;
 			# Cerco l'inizio della commodity da cercare
 		    if ($riga =~ /$what/ ) {$ctr_what++;}
 			# Verifico la fine della commodity
 		    if ($riga =~ /$end_commodity_flag/ && $what ne "all_equations" ) {$ctr_what = 0;}
            @dat = split (/\=/, $riga);
 	           if (@dat[0] !~ /$comment_key/ && $ctr_what > 0) {
                    push @equations, $riga;
 					push @endog_names, @dat[0];
 	            }
 		  }
      }
      #&error("@equations1");
      $n_rows = scalar @equations;
	  chop @equations[$n_rows-1];
 	  @equations[$n_rows-1] = "@equations[$n_rows-1]"."\n";


}

##########################################################################
sub modify {




   @var_names = (@data_names, @endog_names);
   @var_names = sort (@var_names);
   $n_var = scalar @var_names;
   for ($n=0;$n<$n_var;$n++) {
	   if (@var_names[$n] ne @var_names[$n-1]) {
		   push @var_names_temp, @var_names[$n];
	   }
   }
   @var_names = @var_names_temp;
   undef @var_names_temp;

   $i=1;
   push @righe_mod1, "\$method=\"$method\";\n";
   foreach $riga (@equations) {
     @dat = split (/\=/, $riga);
	  # Controllo se ci trovo almeno un parametro (equazione) o nessuno (identit)
      $ctr_ideq="id";
	  foreach $var (@par_names) {
		  if (@dat[1]=~ /$var/ ) {
			  $ctr_ideq="eq";
		  }
      }
	  # Se si vuole calcolo eq per eq si aggiunge il suffisso "estimated" alle equazioni
	  $var_val = @dat[0];
	  if ($ctr_ideq eq "eq" && $method eq "single") {
          @dat[0] = "@dat[0]"."_est";
	  }
	 @dat[0] = "\@"."@dat[0]"."[\$y]";
 	 # Sostituisco i parametri con il loro valore
	 foreach $var (@par_names) {
		    @dat[1] =~ s/$var/${$var}/gi;
			# no problem con i segni meno.. perl capisce che a+-b  "a meno b"! (testato)
     }
     @variabili = split ( /[\+\-\*\/\(\)\,]/, @dat[1]);
	 $n_var_in_riga = scalar @variabili;
	 chop @variabili[$n_var_in_riga-1];

     @variabili = sort (@variabili);
     for ($n=0;$n<$n_var_in_riga;$n++) {
	   if (@variabili[$n] ne @variabili[$n-1]) {
		   push @variabili_temp, @variabili[$n];
	   }
   }
   @variabili = @variabili_temp;
   undef @variabili_temp;

   


	 foreach $variabile (@variabili) {
		 foreach $var (@var_names) {
            if ($variabile eq $var) {
			   # inserisco i controlli se il dato non  un valore numerico
			   for ($i=0;$i<10;$i++) {
                  if (@dat[1] =~ /$variabile\(\-$i\)/ ) {
                         $riga_ctr_punto = "if ( \@${variabile}[\$y-$i] !~ /\\\d/ ) {push \@years_not, \$y; next; }\n";
                         push @righe_mod1, $riga_ctr_punto;
                  }
                  if (@dat[1] =~ /$variabile\(\+$i\)/ ) {
                         $riga_ctr_punto = "if ( \@${variabile}[\$y+$i] !~ /\\\d/ ) {push \@years_not, \$y; next; }\n";
                         push @righe_mod1, $riga_ctr_punto;
                  }
			   }
               if ( @dat[1] =~ /$variabile[^\(]/) {
                         $riga_ctr_punto = "if ( \@${variabile}[\$y] !~ /\\\d/ ) {push \@years_not, \$y; next; }\n";
                         push @righe_mod1, $riga_ctr_punto;
               }
		       @dat[1] =~ s/$variabile/\@${variabile}[\$y]/gi;
			   last;
            }
         }

	 }

	 if ($i < $n_rows) {chop @dat[1];}
	 $riga="@dat[0]"."="."@dat[1]".";"."\n";
	 $i++;
	 push @righe_mod1, $riga;
	 $riga_ctr_ciclo = "if (\$outvar_min eq \"$var_val\"){next;}\n";
	 if (! $all_var) {push @righe_mod1, $riga_ctr_ciclo;}
   }
 undef @equations;

# ..ed ora occupiamoci del massimo!!!! ALLA GRANDE!!
foreach $riga (@righe_mod1) {
     for ($i=0;$i<10;$i++) {
	     $riga =~ s/\[\$y\]\(-$i\)/\[\$y-$i\]/gi;
         $riga =~ s/\[\$y\]\(\+$i\)/\[\$y\+$i\]/gi;
     }


  if ($riga =~ /max\(/i || $riga =~ /min\(/i) {
      @max1 = split (/max\(/i, $riga);
      $iniziale = shift @max1;
      $n_max= scalar (@max1);
      foreach $val (@max1) {
	      @mass_temp = split (/\)/, $val, 2);
          push @max2, @mass_temp[0];
	      push @max2_res, @mass_temp[1];
      }
      for ($i=0;$i<$n_max;$i++) {
	      @max3 = split (/\,/, @max2[$i]);
	      $ia = "massimo"."$i"."a";
	      $ib = "massimo"."$i"."b";
	      $itot = "massimo"."$i";
	      $riga_mod1 = "\${$ia} = @max3[0];\n";
          $riga_mod2 = "\${$ib} = @max3[1];\n";
          $riga_mod3= "if (\$$ia > \$$ib){\$$itot = \$$ia;} else {\$$itot = \$$ib;}\n";
	      push @righe_mod2, $riga_mod1;
	      push @righe_mod2, $riga_mod2;
	      push @righe_mod2, $riga_mod3;
	      $riga_mod4= "$riga_mod4"."\$massimo$i"."@max2_res[$i]";
      }
      $riga_mod_fin_max="$iniziale"."$riga_mod4".";\n";
	  if ($riga_mod_fin_max =~ /min\(/i ) {

           @min1 = split (/min\(/i, $riga_mod_fin_max);
           $iniziale = shift @min1;
           $n_min= scalar (@min1);
           foreach $val (@min1) {
	           @min_temp = split (/\)/, $val, 2);
               push @min2, @min_temp[0];
	           push @min2_res, @min_temp[1];
           }
           for ($i=0;$i<$n_min;$i++) {
	           @min3 = split (/\,/, @min2[$i]);
	           $ia = "minimo"."$i"."a";
	           $ib = "minimo"."$i"."b";
	           $itot = "minimo"."$i";
	           $riga_mod1 = "\${$ia} = @min3[0];\n";
               $riga_mod2 = "\${$ib} = @min3[1];\n";
               $riga_mod3= "if (\$$ia < \$$ib){\$$itot = \$$ia;} else {\$$itot = \$$ib;}\n";
	           push @righe_mod2, $riga_mod1;
	           push @righe_mod2, $riga_mod2;
	           push @righe_mod2, $riga_mod3;
	           $riga_mod5= "$riga_mod5"."\$minimo$i"."@min2_res[$i]";
           }
           $riga_mod_fin_min="$iniziale"."$riga_mod5".";\n";
	       push @righe_mod2, $riga_mod_fin_min;
	       }
         else {
	       push @righe_mod2, $riga_mod_fin_max;
	    }
  
  undef @max2;
  undef @max2_res;
  undef @min2;
  undef @min2_res;
  undef $riga_mod4;
  undef $riga_mod5;
  

  #fine se trovato il max o il min
  }
  else { push @righe_mod2, $riga;}
# fine foreach
}
undef @righe_mod1;

##  Now we join the general model with the national model
    #Open file base for run the model
    open (FLBAS, "<$file_base");
    @rows_base=(<FLBAS>);
    close FLBAS;

    open (FLWR, ">$file_complete");
	#if ($all_var) {
	#	    print FLWR "#!perl\n\n";
	#	    print FLWR "\$what= \"\\$what\";\n";
	#}
    foreach $row_base (@rows_base) {
	   if ($row_base !~ /<<INSERT-HERE>>/) {
		    print FLWR $row_base;
	   }
	   else {
          foreach $row_mod (@righe_mod2) {
	          print FLWR "$row_mod";
          }
	   }
	}
    close FLWR;   

 

}

##########################################################################
sub html_out {

  # print HTML output
  if ($all_var) {
 	  print "Location: $file_complete?what=$what&country=$country\n\n";
  }
  else {
     print "Content-type: text/html\n\n";
     print "<html><head><title>AGMEMOD - $model_title</title>\n";
     print "<body BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#000080\" ALINK=\"#FF0000\">\n";
	 print "<h1 ALIGN=\"CENTER\">AGMEMOD - $model_title - </h1>\n";
	 print "<h3 align=center><br><font color=red>OK! The equation file was made ready to be used with this program</font></h3>\n";
     print "<p><a href=\"javascript:history.go(-1);\">Back</a>\n";
	 print "<table cellspacing=5>\n";
     print "<tr><td>Input file:</td><td>$file_equations</td></tr>\n";
	 print "<tr><td>Output file:</td><td>$file_complete</td></tr>\n";
	 print "</table>\n";
	 print "<form action=model_start.cgi name=visualizza method=get>\n";
	 print "Go to the model:\n";
	 print "<input type=hidden name=country value=$country>\n";
	 print "<br>&nbsp;<input type=radio name=\"action\" value=\"show_query\">&nbsp;Go to the query form\n";
	 print "<br>&nbsp;<input type=radio name=\"action\" value=\"show_data\">&nbsp;Show the database\n";
	 print "<br>&nbsp;<input type=radio name=\"action\" value=\"show_parameters\">&nbsp;Show used parameters\n";
	 print "<br><input type=submit value=\"Go!\">\n";
	 print "</form>\n";


	 print "<p>Equation file as saved:\n";
     print "<br><font face=\"Courier New, Courier\">\n";
	 foreach $riga (@righe_mod2) {
	   print "<br>$riga\n";
     }
     print "<br></FONT>\n";
	 print "</body></html>\n";
  }
  exit;
}


##########################################################################
sub error {

        local($error) = @_;
        print "Content-type: text/html\n\n";
        print "<html><head></head><body><br>-------------------------\n";
        print "<br>Error: $error \n";
        print "<br>&nbsp;<br><a href=\"javascript:history.go(-1);\">&lt;&lt;Back</a>\n";
        print "</body></html>\n";
        exit;
}