#!perl

# Italian model for the AG-MEMOD project


&get_input;
&load_files;
&run_model;
&html_out;

#####################################################################
sub get_input {
use CGI qw(:standard);
    $query = new CGI;
	$country = $query->param('country');
	$ystart = 16;
	$yend   = 22;

	if ($country eq "Italy") {
      $file_parameters = "../parametri/it_model_parameters.txt";
      $file_data       = "../dati/it_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	  $model_title     = "Italian Model";
	}
	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "../parametri/eu11_model_parameters.txt";
      $file_data       = "../dati/eu11_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	  $model_title     = "EU11 Olive Oil and Fats demand model";
	}

}

#################################################################
sub load_files {
	#Open data database
    open (DATA, "<$file_data");
    @hisdatas1=(<DATA>);
    close DATA;
	@testone = @hisdatas1;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
			 # I remove all the blanks
             $hisdata =~ s/ //g;
		     # I change the commas, if presents, with the dot
             if ($data_delimiter ne ",") {$hisdata =~ s/,/./g;}
		     # I change all the letters in lower case
             $hisdata =~ tr/A-Z/a-z/;
             @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/ && @dat[0] ne "") {
                    push @hisdatas, $hisdata;
	            }
			}
          }





    # I load the data
    foreach $hisdata(@hisdatas){
       @dat = split (/$data_delimiter/, $hisdata);
	      $n_values = scalar (@dat); 
		  $i=1;
		  while ($i<$n_values) {
             push @{@dat[0]}, @dat[$i];
			 $i++;
		  }
    }
}

######################################################################
sub run_model {

    $ystart_xxxx = $ystart+1979;
	$yend_xxxx = $yend+1978;
    
<<INSERT-HERE>>
	
}
##########################################################################
sub html_out {
 
  $what =~ s/\\//gi;
  $what =~ s/\*//gi;
  $what =~ s/\#//gi;
  $what =~ tr/a-z/A-Z/;
  print "Content-type: text/html\n\n";
  print "<html><body>\n";
  print "<hr><b><font size=+1>AG-MEMOD - $model_title\n";
  print "<br>Average Elasticity Calculation</font></b><br>&nbsp;\n";
  print "<table>\n";
  print "<tr><td>Country:&nbsp;</td><td>$country</td></tr>\n";
  print "<tr><td>Years:&nbsp;</td><td>$ystart_xxxx - $yend_xxxx</td></tr>\n";
  print "<tr><td>Commodity:&nbsp;</td><td><font size= +1><b>$what</b></font></td></tr>\n";
  print "</table><hr>\n";

  if (@test) {
	  print "TEST: @test\n";
  }
  $temp = "";
  print "<table>\n";
  $n_variabili = scalar @elastdb;
  $count_var=0;
  foreach $val (@elastdb) {
      $count_var++;
	  @dat = split (//, $val);
	  if (@dat[0] ne $temp) {
		  $nome_variabile =  @dat[0];
          $nome_variabile =~ tr/a-z/A-Z/;
		  print "</table>\n<p>($count_var / $n_variabili) <b>Equation:&nbsp;<font color=red>$nome_variabile</font></b>\n";
		  print "<table>\n";
	  }
	  print "<tr><td>&nbsp;-&nbsp;@dat[1]:&nbsp;</td><td>@dat[2]</td></tr>\n";
      $temp = @dat[0];
   }
  print "</table>\n";
  print "<p>Model runned with the $ENV{'SCRIPT_NAME'} perl script.\n";
  print "<br>UNIAN team: <a href=\"mailto:robertoe@dea.unian.it\">Roberto Esposti</a>, <a href=\"mailto:berloni@dea.unian.it\">Davide Berloni</a>, <a href=\"mailto:lobianco@dea.unian.it\">Antonello Lobianco</a>\n";
 # print "<p>&nbsp;<table>\n";
 # print "<tr><td>Data file:&nbsp;</td><td>$file_data</td></tr>\n";
 # print "<tr><td>Parameters file:&nbsp;</td><td>$file_parameters</td></tr>\n";
 # print "<tr><td></td><td><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font></td></tr>\n";
 # print "</table>\n";
  print "</body></html>\n";
  exit;
}


