#!perl

# Italian model for the AG-MEMOD project

$file_base       = "model.pl";

&get_input;
&load_files;
&html_out;

###############################################################
sub get_input {

use CGI qw(:standard);
    $query = new CGI;
	$country = $query->param('country');
	$action = $query->param('action');
	if (!$action) {$action = "show_query";}

if ($country eq "Italy") {
   $file_parameters = "parametri/it_model_parameters.txt";
   $file_data       = "dati/it_model_data.txt";
   $file_equations  = "modelli_grezzi/it_model.eq";
   $file_complete   = "modelli_ok/it_model.cgi";
   $model_title     = "Italian Model";
   $comment_key     = "\\*";
   $par_delimiter   = "\\t";
   $data_delimiter  = "\\t";
   $comm_start_flag = "\\*\\#start_commodity";

}
	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "parametri/eu11_model_parameters.txt";
      $file_data       = "dati/eu11_model_data.txt";
      $file_equations  = "modelli_grezzi/eu11_model.eq";
      $file_complete   = "modelli_ok/eu11_model.cgi";
      $model_title     = "EU11 Olive Oil Demand";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	}

}

#################################################################
sub load_files {

       #Open parameters database
       open (PARAMETRI, "<$file_parameters");
       @parametr1=(<PARAMETRI>);
       close PARAMETRI;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $parametro(@parametr1){
          if ($parametro ne "\n") {
            @par = split (/$par_delimiter/, $parametro);
	           if (@par[0] !~ /$comment_key/) {
				    # I remove all the blanks
                    $parametro =~ s/ //g;
                    @par[0] =~ s/ //g;
					# I change the commas, if presents, with the dot
                    $parametro =~ s/,/./g;
                    @par[0] =~ s/,/./g;
                    push @parametri, $parametro;
					push @par_names, @par[0];
	            }
			}
          }

       foreach $parametro(@parametri){
            @par = split (/$par_delimiter/, $parametro);
			chop @par[1];
	        ${@par[0]}=@par[1];
	   }
  
    #Open data database
    open (DATAREAD, "<$file_data");
    @hisdatas1=(<DATAREAD>);
    close DATAREAD;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
            @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/ && @dat[0] ne "") {
				    # I remove all the blanks
                    $hisdata =~ s/ //g;
					@dat[0] =~ s/ //g;
					# I change the commas, if presents, with the dot
                    $hisdata =~ s/,/./g;
                    @dat[0] =~ s/,/./g;
                    push @hisdatas, $hisdata;
					push @data_names, @dat[0];
	            }
			}
          }

    foreach $hisdata(@hisdatas){
       @dat = split (/$data_delimiter/, $hisdata);
	      $n_values = scalar (@dat); 
		  $i=1;
		  while ($i<$n_values) {
             push @{@dat[0]}, @dat[$i];
			 $i++;
		  }
    }

    #Open equation model
    open (EQUAZ, "<$file_equations");
    @equations1=(<EQUAZ>);
    close EQUAZ;
	  
	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $riga(@equations1){
          if ($riga ne "\n") {
		    # I remove all the blanks
            $riga =~ s/ //g;
			# segno con dei trattini l'inizio di una commodity
			if ($riga =~ /$comm_start_flag/i ) {@dat[0] = "- - - - - -";}
			else {@dat = split (/\=/, $riga);}
	           if (@dat[0] !~ /$comment_key/) {
					push @endog_names, @dat[0];
	            }
			}
          }


  
}

##########################################################################
sub html_out {

  # print HTML output
  print "Content-type: text/html\n\n";
  print "<html><head><title>AGMEMOD - $model_title</title>\n";
  print "<body BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#000080\" ALINK=\"#FF0000\">\n";
  #######
  if ($action eq "show_parameters") {
   print "<hr>Used Parameters<br><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font><br><hr>\n";
	   foreach $parametro(@parametri){
            @par = split (/$par_delimiter/, $parametro);
            print "<br> <b><font color=red>@par[0]</font>:</b> @par[1] \n";
       }
  }
  
  #######
  elsif ($action eq "show_data") {
   print "<hr>Used Data<br><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font><br><hr>\n";
	  #$test = @BAASHIT[2] + @BAASHIT[3];
      #print "Test: $test\n";
	  print "<table>\n";

	  foreach $hisdata(@hisdatas){
          @dat = split (/$data_delimiter/, $hisdata);
	      print "<tr><td><b><font color=red>@dat[0]</font>:</b></td>\n";
		  foreach $value (@{@dat[0]}) {
			  print "<td width=50>$value</td>\n";
		  }
	      print "</tr>\n";
      }
	  print "</table>\n";
  }

  ########
  elsif ($action eq "show_query") {
     print "<h1 ALIGN=\"CENTER\">AGMEMOD - $model_title - Input Form</h1>\n";
     print "<form name=query action=\"${file_complete}\" method=get>\n";
	 print "<input type=hidden name=country value=\"$country\">\n";
     print "Variable:&nbsp;<select name=outvar>\n";
	 foreach $equation(@endog_names){
         print "<option>$equation</option>\n";
     }
     print "</select>\n";
     print "<br><input type=submit value=\"Send the query and run the model\"></form>\n";

     print "<a href=?action=show_parameters&country=$country>Check parameters</a>\n";
     print "<br><a href=?action=show_data&country=$country>Check data</a>\n";
	 print "<form name=model_building action=join.cgi method=get>\n";
	 print "<p><table border=1><tr><td>\n";
	 print "<i><b>Make an usable model equation file:</b>\n";
	 print "<input type=hidden name=country value=$country>\n";
	 print "<br><input type=radio name=method value=all>&nbsp; simultaneous running\n";
	 print "<br><input type=radio name=method value=single>&nbsp; single equation running\n";
     print "<br>Parts of the model to be runned:\n";
	 print "<br><select name=what>\n";
	 print "<option selected>All the commodities</option>\n";
	 print "<option>Grains and oilseeds</option>\n";
	 print "<option>Livestock and dairy</option>\n";
	 print "<option>Sugar beet</option>\n";
	 print "<option>Potatoes</option>\n";
	 print "<option>Oranges</option>\n";
	 print "<option>Olive oil</option>\n";
	 print "<option>Tomato paste</option>\n";
	 print "<option>Tobacco</option></select>\n";
	 print "<br><input type=submit value=\"make the model\"></form></i></td></tr></table>\n";
     print "<br><a href=\"javascript:history.go(-1);\">Back</a>\n";
     print "<br><a href=\"../../agmemod/index.htm\">Home</a>\n";

  }
  else {
      &error("Parameter action not valid or not valid: $action");
  }
  print "</body></html>\n";
  exit;
}


##########################################################################
sub error {

        local($error) = @_;
        print "Content-type: text/html\n\n";
        print "<html><head></head><body><br>-------------------------\n";
        print "<br>ERROR: $error \n";
        print "<br>&nbsp;<br><a href=\"javascript:history.go(-1);\">&lt;&lt;Back</a>\n";
        print "</body></html>\n";
        exit;
}